<?php

/**
* Administration form
*
* @ingroup forms
* @see form_tooltips_admin_form_validate()
* @see form_tooltips_admin_form_submit()
*/
function form_tooltips_admin_settings() {
   // Add tooltips options
  $form['visibility'] = array(
    '#type' => 'fieldset',
    '#title' => t('Visibility options'),
    '#collapsible' => TRUE,
    '#collapsed' => FALSE,
  );
 
  $form['visibility']['form_tooltips_scope'] = array(
    '#type' => 'radios',
    '#title' => t('Show tooltips on specific forms'),
    '#options' => array(
      t('Show on every form except the listed forms.'),
      t('Show on only the listed forms.'),
    ),
    '#default_value' => variable_get('form_tooltips_scope', 0),
  );
 
  $form['visibility']['form_tooltips_forms'] = array(
    '#type' => 'textarea',
    '#title' => t('Forms which have tooltips'),
    '#default_value' => variable_get('form_tooltips_forms', ''),
    '#cols' => 40,
    '#rows' => 3,
    '#resizable' => TRUE,
  );
 
  return system_settings_form($form);
}

/**
* Correct textareas
*/
function _form_tooltips_correct_fields(&$field) {
  // Convert separate chars to line return
  $field = str_replace(array(',', ';', ' ', "\r\n", "\r"), "\n", $field);
 
  // Convert to array and remove empty elements
  $field = array_filter(explode("\n", $field));
 
  // Store as string
  $field = implode("\n", $field);
}

/**
* Verify that a new path is valid
*/
function form_tooltips_admin_settings_validate($form, &$form_state) {
  // Correct fields
  _form_tooltips_correct_fields($form_state['values']['form_tooltips_forms']);
 
  // Get forms id in an array
  $forms_id = explode("\n", $form_state['values']['form_tooltips_forms']);
 
  // Forms loop
  foreach ($forms_id as $form_id) {
    // If no value, continue
    if (!($form_id)) {
      continue;
    }
   
    // If no function with form id name, so form id doesn't exists
    if (!(function_exists($form_id))) {
      form_set_error('forms', t('The form %form_id doesn\'t exists.', array('%form_id' => $form_id)));
    }
  }
}
// Remove the PHP end tag
?>
